diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index 241dada68..8fa77fe57 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -11,7 +11,6 @@ import net.minecraft.client.gui.achievements.data.AchievementPages;
 import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -862,7 +861,7 @@ public class ScreenAchievements extends Screen
                 boxHeight += 12;
             }
             boxRender = tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
-            FontHelper.renderWidthConstrained(Tessellator.instance, desc, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xffa0a0a0).call(this.fontRenderer);
+            this.fontRenderer.renderWidthConstrained(Tessellator.instance, desc, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xffa0a0a0).call();
             if(statsCounter.isUnlocked(achievement)) { // Add taken string to bottom
                 drawStringShadow(fontRenderer, I18n.getInstance().translateKey("gui.achievements.label.taken"), boxRender[0] + padding, boxRender[1] + boxHeight + 8 + padding, 0xff9090ff);
             }
@@ -871,7 +870,7 @@ public class ScreenAchievements extends Screen
             String msg = I18n.getInstance().translateKeyAndFormat("gui.achievements.label.requires", achievement.parent.getStatName());
             int boxHeight = MathHelper.ceil(fontRenderer.heightOfConstrainedChars(msg, boxWidth));
             boxRender = tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
-            FontHelper.renderWidthConstrained(Tessellator.instance, msg, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xff705050).call(this.fontRenderer);
+            this.fontRenderer.renderWidthConstrained(Tessellator.instance, msg, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xff705050).call();
         }
         int color = statsCounter.canUnlock(achievement) ? achievement.getType().colorName : achievement.getType().colorNameLocked;
         drawStringShadow(fontRenderer, name, boxRender[0] + padding, boxRender[1] + padding, color);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index 8c7501e44..d64dcbbd0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -22,7 +22,6 @@ import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.net.command.ClientCommandSource;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.command.*;
 import net.minecraft.core.net.command.util.CommandHelper;
@@ -167,7 +166,7 @@ public class GuiElementChatSuggestions extends Gui {
 
             int textX = (int) (leftMargin + 1 + (this.anchor.xPosition * (largestSuggestion - fontRenderer.stringWidth(suggestionText))));
 
-            FontHelper.render(Tessellator.instance, colorCode + suggestionText, textX, minY + suggestionBoxHeight - suggestionHeight + 3).setShadow().setColor(0xE0E0E0).call(fontRenderer);
+            fontRenderer.render(Tessellator.instance, colorCode + suggestionText, textX, minY + suggestionBoxHeight - suggestionHeight + 3).setShadow().setColor(0xE0E0E0).call();
         }
 
         if (this.isHoveringOverSuggestions(mouseX, mouseY) && this.suggestions.get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get()).getTooltip() != null) {
@@ -186,7 +185,7 @@ public class GuiElementChatSuggestions extends Gui {
         minY += (int) CommandHelper.linearInterpolation(this.anchor.yPosition, heightIndex * 12, -12 - heightIndex * 12);
 
         this.drawRect(leftMargin, minY, stringWidth + leftMargin + 1, minY + 12, Integer.MIN_VALUE);
-        FontHelper.render(Tessellator.instance, text, leftMargin + 1, minY + 2).setShadow().setColor(0xE0E0E0).call(fontRenderer);
+        fontRenderer.render(Tessellator.instance, text, leftMargin + 1, minY + 2).setShadow().setColor(0xE0E0E0).call();
     }
 
     private List<String> getCommandUsage(int cursor) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
index cb571c2f0..083cadd5f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
@@ -3,7 +3,6 @@ package net.minecraft.client.gui.createworld;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.paged.PageComponent;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -47,7 +46,7 @@ public abstract class ButtonComponent
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
-        FontHelper.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call(mc.font);
+        mc.font.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call();
         resetButton.enabled = !isDefault();
         renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
         int stringWidth = mc.font.stringWidth(translated);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java b/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
index f0318cdd6..ca8ffc6ab 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
@@ -4,7 +4,6 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.gui.paged.CallbackComponent;
 import net.minecraft.client.gui.paged.OnValueChangedCallback;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
@@ -53,7 +52,7 @@ public class TextFieldComponent
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
-        FontHelper.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call(mc.font);
+        mc.font.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call();
         int stringWidth = mc.font.stringWidth(translated);
         int lineMaxX = x + width - BUTTON_WIDTH - 8;
         drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 859aa3078..510108ee0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -17,7 +17,6 @@ import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.HumanArmorShape;
@@ -435,7 +434,7 @@ public class HudIngame extends Gui
                         color = 0xFFFFFF;
                     }
                     drawStringShadow(fontRenderer, "Better than Adventure! ", tsp, tsp + lineHeight * line, color);
-                    drawStringShadow(fontRenderer, Global.VERSION, FontHelper.getLastEndingX(), tsp + lineHeight * line++, 0xffffff);
+                    drawStringShadow(fontRenderer, Global.VERSION, fontRenderer.getLastEndingX(), tsp + lineHeight * line++, 0xffffff);
                 }
                 if (mc.gameSettings.fpsInOverlay.value)
                 {
@@ -859,7 +858,7 @@ public class HudIngame extends Gui
                 y -= (h + 2);
                 drawRect(xPad, y - sp - 1, xPad + MAX_CHAT_WIDTH, y + h - sp + 1, alpha / 2 << 24);
                 GL11.glEnable(GL_BLEND);
-                FontHelper.renderWidthConstrained(Tessellator.instance, message, xPad, y, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call(this.fontRenderer);
+                this.fontRenderer.renderWidthConstrained(Tessellator.instance, message, xPad, y, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
index ca6913b97..be8a27ca2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HubComponentSubtitles.java
@@ -5,7 +5,6 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.subtitles.SubtitleTracker;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.sound.SoundRepository;
 import org.lwjgl.opengl.GL11;
@@ -102,13 +101,13 @@ public class HubComponentSubtitles extends HudComponentMovable {
                 if (subtitle != null) {
                     gui.drawRect(xRight - maxMessageWidth - xPad * 2, yBottom + y2 - 1, xRight, yBottom + y2 + 8, alpha / 2 << 24);
                     GL11.glEnable(GL_BLEND);
-                    FontHelper.renderCentered(Tessellator.instance, subtitle, xRight - (maxMessageWidth) / 2 - xPad, yBottom + y2).setShadow().setColor(0xFFFFFF + (alpha << 24)).call(mc.font);
+                    mc.font.renderCentered(Tessellator.instance, subtitle, xRight - (maxMessageWidth) / 2 - xPad, yBottom + y2).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
                     if (mc.thePlayer != null) {
                         final double sin = Math.sin(entry.getRelativeAngle(mc.thePlayer) + Math.PI/2);
                         if (sin > 0.7) {
-                            FontHelper.render(Tessellator.instance, "<", xRight - maxMessageWidth - xPad, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call(mc.font);
+                            mc.font.render(Tessellator.instance, "<", xRight - maxMessageWidth - xPad, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call();
                         } else if (sin < -0.7) {
-                            FontHelper.render(Tessellator.instance, ">", xRight - mc.font.stringWidth(">") - xPad/2, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call(mc.font);
+                            mc.font.render(Tessellator.instance, ">", xRight - mc.font.stringWidth(">") - xPad/2, yBottom + y2).setColor(0xFFFFFF + (alpha << 24)).call();
                         }
                     }
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
index aa4fe23b9..559d1f4ef 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
@@ -9,7 +9,6 @@ import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.command.TextFormatting;
 import org.jetbrains.annotations.NotNull;
@@ -87,7 +86,7 @@ public class HudComponentLog extends HudComponentMovable {
                 int acc = 0;
                 int c = 0;
                 for (; c < line.length(); c++) {
-                    final int cWidth = mc.font.charWidth(line.charAt(c));
+                    final int cWidth = mc.font.getFont().charWidth(line.charAt(c));
                     if (acc + cWidth + ellipsisWidth > WIDTH) {
                         break;
                     }
@@ -167,11 +166,11 @@ public class HudComponentLog extends HudComponentMovable {
 
             final int lineWidth = sr.stringWidth(line);
             if (anchor == null || anchor == ComponentAnchor.TOP_LEFT || anchor == ComponentAnchor.CENTER_LEFT || anchor == ComponentAnchor.BOTTOM_LEFT) {
-                FontHelper.render(Tessellator.instance, line, x + PADDING, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call(sr);
+                sr.render(Tessellator.instance, line, x + PADDING, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call();
             } else if (anchor == ComponentAnchor.TOP_CENTER || anchor == ComponentAnchor.CENTER || anchor == ComponentAnchor.BOTTOM_CENTER) {
-                FontHelper.render(Tessellator.instance, line, x + PADDING + WIDTH / 2 - lineWidth / 2, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call(sr);
+                sr.render(Tessellator.instance, line, x + PADDING + WIDTH / 2 - lineWidth / 2, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call();
             } else {
-                FontHelper.render(Tessellator.instance, line, x + PADDING + WIDTH - lineWidth, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call(sr);
+                sr.render(Tessellator.instance, line, x + PADDING + WIDTH - lineWidth, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call();
             }
         }
         GL11.glDisable(GL11.GL_BLEND);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
index 29013ee1c..0256cad4a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
@@ -83,7 +83,7 @@ public class CharKey extends Key{
                 size,
                 TextureRegistry.getTexture("minecraft:gui/screen/keyboard/radial_background"));
 
-            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight()/2 + 4 + originY, texColor);
+            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.getFont().fontHeight()/2 + 4 + originY, texColor);
 
             final double dx;
             final double dy;
@@ -114,7 +114,7 @@ public class CharKey extends Key{
             GL11.glDisable(GL11.GL_BLEND);
             GL11.glPopMatrix();
         } else {
-            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight()/2 + 4 + originY, texColor);
+            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.getFont().fontHeight()/2 + 4 + originY, texColor);
         }
         GL11.glColor4f(1f, 1f, 1f, 1f);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
index 6fcd2c098..baf0ddd0b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
@@ -126,7 +126,7 @@ public class ListenerTextFieldElement extends ListenerButtonElement implements I
         {
             boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
             int cursor = editor.getCursor();
-            int maxDisplayableChars = this.width / fontRenderer.charWidth('_');
+            int maxDisplayableChars = this.width / fontRenderer.getFont().charWidth('_');
 
             if (!text.isEmpty() || isFocused){
                 if(prefaceText.length() + text.length() <= maxDisplayableChars-1){
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
index ebd819aa1..f77a8b087 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
@@ -6,7 +6,6 @@ import java.util.ArrayList;
 import java.util.List;
 
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.opengl.GL11;
 
@@ -73,7 +72,7 @@ public class AvailableTexturePackListComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         if (availablePacks.isEmpty()) {
-            FontHelper.renderCentered(Tessellator.instance, I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4).setShadow().setColor(0x5F7F7F7F).call(mc.font);
+            mc.font.renderCentered(Tessellator.instance, I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4).setShadow().setColor(0x5F7F7F7F).call();
         }
         for (int i = 0; i < availablePacks.size(); i++) {
             TexturePackButton button = availablePacks.get(i);
@@ -169,21 +168,21 @@ public class AvailableTexturePackListComponent
 
 			if(format == Global.TEXTURE_PACK_FORMAT) {
 				// Correct version
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call(mc.font);
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
 			}else if(format == -1) {
 				// Manifest error
-                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call(mc.font);
+                mc.font.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}else {
 				// Wrong texture pack version
 				I18n i18n = I18n.getInstance();
-                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call(mc.font);
-                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + this.height + 2, y + 12).setColor(0x808080).call(mc.font);
-                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + this.height + 2, y + 22).setColor(0x808080).call(mc.font);
+                mc.font.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+                mc.font.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + this.height + 2, y + 12).setColor(0x808080).call();
+                mc.font.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + this.height + 2, y + 22).setColor(0x808080).call();
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}
 
@@ -194,7 +193,7 @@ public class AvailableTexturePackListComponent
 
             String version = texturePack.manifest.getPackVersion();
             int versionWidth = mc.font.stringWidth(version);
-            FontHelper.render(Tessellator.instance, texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1).setColor(rgbVersion).call(mc.font);
+            mc.font.render(Tessellator.instance, texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1).setColor(rgbVersion).call();
         }
         public void setupButton(int x, int y, int width, int mouseX, int mouseY){
             button.setX(x + width - button.width - 1);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index db2477777..76ae1a7aa 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.lang.I18n;
@@ -47,7 +46,7 @@ public abstract class ButtonComponent
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
-        FontHelper.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call(mc.font);
+        mc.font.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call();
         resetButton.enabled = !isDefault();
         renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
         int stringWidth = mc.font.stringWidth(translated);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index 169e03488..bd31099ab 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.options.components;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.lang.Language;
@@ -142,8 +141,8 @@ public class LanguagePackListComponent
                 }
                 empty = false;
             }
-            FontHelper.renderCentered(Tessellator.instance, fullName, x + (width / 2), y + 1).setShadow().call(this.mc.font);
-            FontHelper.renderCentered(Tessellator.instance, empty ? "Unknown Credits" : credits, x + width / 2, y + 12).setShadow().setColor(0x808080).call(this.mc.font);
+            this.mc.font.renderCentered(Tessellator.instance, fullName, x + (width / 2), y + 1).setShadow().call();
+            this.mc.font.renderCentered(Tessellator.instance, empty ? "Unknown Credits" : credits, x + width / 2, y + 12).setShadow().setColor(0x808080).call();
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
index 2687ef45a..a4216a707 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ItemElement;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
@@ -85,7 +84,7 @@ public class OptionsCategory
         {
             textColor = 0xFFFFA0;
         }
-        FontHelper.render(Tessellator.instance, (this.collapsed ? "▷" : "▽"), x, y + PADDING + 10).setShadow().setColor(textColor).call(mc.font);
+        mc.font.render(Tessellator.instance, (this.collapsed ? "▷" : "▽"), x, y + PADDING + 10).setShadow().setColor(textColor).call();
 
         int xOffset = 10;
         if (icon != null)
@@ -93,7 +92,7 @@ public class OptionsCategory
             renderItem.render(icon, x + 11, y + PADDING + 5);
             xOffset += 20;
         }
-        FontHelper.render(Tessellator.instance, i18n.translateKey(this.translationKey), x + xOffset, y + PADDING + 10).setShadow().setColor(textColor).call(mc.font);
+        mc.font.render(Tessellator.instance, i18n.translateKey(this.translationKey), x + xOffset, y + PADDING + 10).setShadow().setColor(textColor).call();
         if (!collapsed) {
             int componentY = TOP_SPACING;
             for (OptionsComponent component : components)
